
import com.lowagie.text.Document;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import com.lowagie.text.DocumentException;
import com.lowagie.text.Rectangle;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfWriter;
import java.awt.Color;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

/**
 *
 * @author ismal
 */
public class DHWtoPDF {

private Document document;
private int paperwidth,  paperheight;
private float delta;
private boolean bGridH,  bGridV;
private float StrokeThick,  GridThick;
private String path;
private PdfWriter writer;

public DHWtoPDF(String path, int paperwidth, int paperheight,
                  float delta, boolean bGridH, boolean bGridV, float StrokeThick, float GridThick) {
   this.paperwidth = paperwidth;
   this.paperheight = paperheight;
   this.delta = delta;
   this.bGridH = bGridH;
   this.bGridV = bGridV;
   this.StrokeThick = StrokeThick;
   this.GridThick = GridThick;
   this.path = path;

   // step 1: creation of a document-object
   document = new Document(new Rectangle(0, 0,
                     getPaperCoordinate(paperwidth), getPaperCoordinate(paperheight)));
   try {
      // step 2: creation of the writer
      writer = PdfWriter.getInstance(document, new FileOutputStream(path));
      // step 3: we open the document
      document.open();
   } catch (DocumentException de) {
      System.err.println(de.getMessage());
   } catch (IOException ioe) {
      System.err.println(ioe.getMessage());
   }

}

public void convert(ArrayList<ArrayList<int[]>> AllStrokes) {

   PdfContentByte cb = writer.getDirectContent();
   //writer.setPageEmpty(false);
   // document.newPage();

   // find the dot in the top right corner in the 2cm x 4cm box
   // and start the horizontal grid from there 
   //double onemm = 39.3174176;
   float grid_y = paperheight;
   for (int i = 0; i < AllStrokes.size(); i++) {
      if ((AllStrokes.get(i).get(0)[0] > 6800) &&
                        (AllStrokes.get(i).get(0)[1] > 9800) &&
                        (AllStrokes.get(i).size() < 10)) {
         grid_y = AllStrokes.get(i).get(0)[1];
      }
   }

   // add lines 
   cb.setColorStroke(new Color(210, 210, 230));
   cb.setLineWidth(GridThick);

   if (bGridV) {
      for (float i = 0; i < getPaperCoordinate(paperwidth); i += delta) {
         cb.moveTo(i, 0);
         cb.lineTo(i, getPaperCoordinate(paperheight));
         cb.stroke();
      }
   }
   if (bGridH) {
      for (float j = getPaperCoordinate(grid_y); j >= 0; j -= delta) {
         cb.moveTo(0, j);
         cb.lineTo(getPaperCoordinate(paperwidth), j);
         cb.stroke();
      }
   }
   if (bGridH) {
      for (float j = getPaperCoordinate(grid_y); j < getPaperCoordinate(paperheight); j += delta) {
         cb.moveTo(0, j);
         cb.lineTo(getPaperCoordinate(paperwidth), j);
         cb.stroke();
      }
   }

   // add writing 
   cb.setColorStroke(Color.black);
   cb.setLineWidth(StrokeThick);
   cb.setLineJoin(PdfContentByte.LINE_JOIN_ROUND);

   for (int i = 0; i < AllStrokes.size(); i++) {
      float x = getPaperCoordinate(AllStrokes.get(i).get(0)[0]);
      float y = getPaperCoordinate(AllStrokes.get(i).get(0)[1]);
      cb.moveTo(x, y);
      for (int j = 1; j < AllStrokes.get(i).size(); j++) {
         x = getPaperCoordinate(AllStrokes.get(i).get(j)[0]);
         y = getPaperCoordinate(AllStrokes.get(i).get(j)[1]);
         cb.lineTo(x, y);
      }
      cb.stroke();
   }
}

private float getPaperCoordinate(double x) {
   return ((float) (x / 1000.0 * 72.0 + 0.999999));

}

public void addNewPage() {
   boolean b = document.newPage();
}

public void closeDocument() {
   document.close();
}
}